#ifndef ARBOL1_H
#define ARBOL1_H

#include <Vector>
#include <Arbol.H>




class Rango
{

   double min, max ;

   public:

   Rango
   (
      double _min,
      double _max
   )
   : min(_min)
   , max(_max)
   { }

   Rango()
   {
     min = 0.0 ;
     max = 0.0 ;
   }

   double LeeValor() ;

} ;



class Arbol1 : public Arbol
{

   Rango radSegmento ;

   Rango fRedRadSegmento ;
   Rango fRedAltSegmento ;

   unsigned numRamif ;

   static const unsigned maxRamif = 100 ;

   Rango altRamif[maxRamif] ;

   Rango angDesvRamif[maxRamif] ;
   Rango angRotaRamif[maxRamif] ;

   int nivelMaximo ;

   Arbol * hojas ;

   public:

   Arbol1() ;

   void EscribirEn
   (
       std::ostream & os
   ) ;

   virtual void Rama
   (
      int             nivelActual ,
      const RefSys &  ejeTronco ,
      std::ostream &       os
   ) ;

   Vector3d EvaluaCilindro
   (
      const RefSys & eje ,
      double         u ,
      double         v
   )
      const  ;


   void GeneraMallaCilindrica
   (
      const RefSys & eje ,
      std::ostream &      os
   )
      const ;

} ;

#endif
