#include <Hoja1.H>



void Hoja1::Rama
(
   int             nivelActual ,
   const RefSys &  ejeTronco ,
   std::ostream &       os
)
{
#define W 0.07
#define N 8

   RefSys local( Vector3d(0,0,0), Vector3d(W,0,0), Vector3d(0,W,0), Vector3d(0,0,W) ) ;


   Vector3d vloc[N], v[N]   ;

   vloc[0] = Vector3d( 0, 0, 0) ;
   vloc[1] = Vector3d(-4, 3, 0) ;
   vloc[2] = Vector3d(-2, 3, 0) ;
   vloc[3] = Vector3d(-2, 6, 0) ;
   vloc[4] = Vector3d( 0, 4, 0) ;
   vloc[5] = Vector3d( 2, 6, 0) ;
   vloc[6] = Vector3d( 2, 3, 0) ;
   vloc[7] = Vector3d( 4, 3, 0) ;


   for(int i=0 ; i<8 ; i++ )
   {
       Vector3d vv = local.PuntoLocalAGlobal( vloc[i] ) ;

       v[i] = ejeTronco.PuntoLocalAGlobal( vv ) ;
   }

   Vector3d normal = (ejeTronco.VectorLocalAGlobal(Vector3d(0,0,1.0))).Normalized() ;

   os   << std::endl << " "
        << std::endl << "// hoja1: cara 'delantera'"
        << std::endl << "begin mesh"
        << std::endl << "   begin vertexs" ;

   for(int i=0 ; i<8 ; i++ )
   {
       os << std::endl << "        normal " << normal
            << std::endl << "        " << v[i] ;
   }

   os   << std::endl << "   end vertexs"
        << std::endl << "   begin faces "
        << std::endl << "      rgb (0.0,1.0,0.0) "
        << std::endl << "      (2,1,0)"
        << std::endl << "      (4,2,0)"
        << std::endl << "      (4,3,6)"
        << std::endl << "      (6,4,0)"
        << std::endl << "      (6,5,4)"
        << std::endl << "      (0,7,6)"
        << std::endl << "   end faces"
        << std::endl << "end mesh" ;

   // caras "de atras"

   os   << std::endl << "// hoja1: cara 'trasera'"
        << std::endl << "begin mesh"
        << std::endl << "   begin vertexs" ;

   // desplaza vertices en Z un poco (en relacion al ancho de la hoja, que es 8 unidades
   // en el sistema de referencia local)

   for( int i=0 ; i<8 ; i++ )
   {
       vloc[i] -= Vector3d(0,0,0.2) ;

       Vector3d vv = local.PuntoLocalAGlobal( vloc[i] ) ;

       v[i] = ejeTronco.PuntoLocalAGlobal( vv ) ;
   }

   // cambia la normal, of course

   normal = (-1.0)*normal ;

   // escribe vertices

   for(int i=0 ; i<8 ; i++ )
   {
       os << std::endl << "        normal " << normal
            << std::endl << "        " << v[i] ;
   }

   // escribe caras con los vertices en el orden contrario

   os   << std::endl << "   end vertexs"
        << std::endl << "   begin faces "
        << std::endl << "      rgb (0.0,1.0,0.0) "
        << std::endl << "      (0,1,2)"
        << std::endl << "      (0,2,4)"
        << std::endl << "      (6,3,4)"
        << std::endl << "      (0,4,6)"
        << std::endl << "      (4,5,6)"
        << std::endl << "      (6,7,0)"
        << std::endl << "   end faces"
        << std::endl << "end mesh" ;
}

